"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var path_1 = __importDefault(require("path"));
var fs_extra_1 = __importDefault(require("fs-extra"));
var is_ci_1 = __importDefault(require("is-ci"));
var jimp_processor_1 = __importDefault(require("./jimp-processor"));
var pixel_differ_1 = __importDefault(require("./pixel-differ"));
var mugshot_screenshotter_1 = __importDefault(require("./mugshot-screenshotter"));
var MugshotMissingBaselineError = /** @class */ (function (_super) {
    __extends(MugshotMissingBaselineError, _super);
    function MugshotMissingBaselineError() {
        var _this = _super.call(this, 'Missing baseline') || this;
        // https://github.com/Microsoft/TypeScript/wiki/Breaking-Changes#extending-built-ins-like-error-array-and-map-may-no-longer-work
        Object.setPrototypeOf(_this, MugshotMissingBaselineError.prototype);
        return _this;
    }
    return MugshotMissingBaselineError;
}(Error));
exports.MugshotMissingBaselineError = MugshotMissingBaselineError;
var Mugshot = /** @class */ (function () {
    /**
     * @param browser
     * @param resultsPath
     * @param fs
     * @param pngDiffer
     * @param pngProcessor
     * @param screenshotter
     * @param createMissingBaselines Defaults to false in a CI env, true otherwise.
     * @param updateBaselines
     */
    function Mugshot(browser, resultsPath, _a) {
        var _b = _a === void 0 ? {} : _a, _c = _b.fs, fs = _c === void 0 ? fs_extra_1.default : _c, _d = _b.pngDiffer, pngDiffer = _d === void 0 ? new pixel_differ_1.default() : _d, _e = _b.pngProcessor, pngProcessor = _e === void 0 ? new jimp_processor_1.default() : _e, _f = _b.screenshotter, screenshotter = _f === void 0 ? new mugshot_screenshotter_1.default(browser, pngProcessor) : _f, _g = _b.createMissingBaselines, createMissingBaselines = _g === void 0 ? !is_ci_1.default : _g, _h = _b.updateBaselines, updateBaselines = _h === void 0 ? false : _h;
        this.browser = browser;
        this.resultsPath = resultsPath;
        this.fs = fs;
        this.pngDiffer = pngDiffer;
        this.pngProcessor = pngProcessor;
        this.screenshotter = screenshotter;
        this.createMissingBaselines = createMissingBaselines;
        this.updateBaselines = updateBaselines;
    }
    // eslint-disable-next-line lines-between-class-members,no-dupe-class-members
    Mugshot.prototype.check = function (name, selectorOrOptions, options) {
        if (options === void 0) { options = {}; }
        return __awaiter(this, void 0, void 0, function () {
            var selector, expectedPath, baselineExists, actual, expected, result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (typeof selectorOrOptions === 'string') {
                            selector = selectorOrOptions;
                        }
                        else if (typeof selectorOrOptions === 'object') {
                            // eslint-disable-next-line no-param-reassign
                            options = selectorOrOptions;
                        }
                        expectedPath = path_1.default.join(this.resultsPath, name + ".png");
                        return [4 /*yield*/, this.fs.pathExists(expectedPath)];
                    case 1:
                        baselineExists = _a.sent();
                        if (!baselineExists) {
                            if (this.createMissingBaselines || this.updateBaselines) {
                                return [2 /*return*/, this.writeBaseline(expectedPath, options, selector)];
                            }
                            throw new MugshotMissingBaselineError();
                        }
                        else if (this.updateBaselines) {
                            return [2 /*return*/, this.writeBaseline(expectedPath, options, selector)];
                        }
                        return [4 /*yield*/, this.getScreenshot(selector, options)];
                    case 2:
                        actual = _a.sent();
                        return [4 /*yield*/, this.fs.readFile(expectedPath)];
                    case 3:
                        expected = _a.sent();
                        return [4 /*yield*/, this.pngDiffer.compare(expected, actual)];
                    case 4:
                        result = _a.sent();
                        if (!result.matches) {
                            return [2 /*return*/, this.diff(name, expectedPath, expected, result.diff, actual)];
                        }
                        return [2 /*return*/, {
                                matches: true,
                                expected: expected,
                                expectedPath: expectedPath
                            }];
                }
            });
        });
    };
    Mugshot.prototype.writeBaseline = function (expectedPath, options, selector) {
        return __awaiter(this, void 0, void 0, function () {
            var expected;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.getScreenshot(selector, options)];
                    case 1:
                        expected = _a.sent();
                        return [4 /*yield*/, this.fs.outputFile(expectedPath, expected)];
                    case 2:
                        _a.sent();
                        return [2 /*return*/, {
                                matches: true,
                                expected: expected,
                                expectedPath: expectedPath
                            }];
                }
            });
        });
    };
    Mugshot.prototype.diff = function (name, expectedPath, expected, diff, actual) {
        return __awaiter(this, void 0, void 0, function () {
            var diffPath, actualPath;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        diffPath = path_1.default.join(this.resultsPath, name + ".diff.png");
                        actualPath = path_1.default.join(this.resultsPath, name + ".actual.png");
                        return [4 /*yield*/, this.fs.outputFile(diffPath, diff)];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, this.fs.outputFile(actualPath, actual)];
                    case 2:
                        _a.sent();
                        return [2 /*return*/, {
                                matches: false,
                                expected: expected,
                                actual: actual,
                                diff: diff,
                                expectedPath: expectedPath,
                                diffPath: diffPath,
                                actualPath: actualPath
                            }];
                }
            });
        });
    };
    Mugshot.prototype.getScreenshot = function (selector, options) {
        return __awaiter(this, void 0, void 0, function () {
            var _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        if (!selector) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.screenshotter.takeScreenshot(selector, options)
                            // eslint-disable-next-line no-return-await
                        ];
                    case 1:
                        _a = _b.sent();
                        return [3 /*break*/, 4];
                    case 2: return [4 /*yield*/, this.screenshotter.takeScreenshot(options)];
                    case 3:
                        _a = _b.sent();
                        _b.label = 4;
                    case 4: return [2 /*return*/, _a];
                }
            });
        });
    };
    return Mugshot;
}());
exports.default = Mugshot;
//# sourceMappingURL=mugshot.js.map