/// <reference types="node" />
import PNGDiffer, { DiffResult } from '../interfaces/png-differ';
import { Color } from '../vendor/pixelmatch';
interface PixelDifferOptions {
    /**
     * The color used to mark different pixels.
     */
    diffColor?: Color;
    /**
     * A number between 0 and 1 representing the max difference in %
     * between 2 pixels to be considered identical. 0 means the pixel
     * need to be identical, 1 means two completely different images
     * will be identical. 0.1 means black (#000) and 90% gray (0a0a0a)
     * will be identical.
     */
    threshold?: number;
}
export default class PixelDiffer implements PNGDiffer {
    private readonly diffColor;
    private readonly threshold;
    constructor({ diffColor, threshold }?: PixelDifferOptions);
    compare: (expected: Buffer, actual: Buffer) => Promise<DiffResult>;
}
export {};
